#include "z80ex-0.15\include\z80ex.h"
#include "Attach_funcs.h"
#include "defines.h"

int cnt_z80read = 0;
int cnt_z80write = 0;
int cnt_z80input = 0;
int cnt_z80output = 0;
int cnt_frameStart = 0;
int cnt_afterFrameRender = 0;
int cnt_sdl = 0;
int cnt_reset = 0; 


bool (* hnd_z80read[MAX_HANDLERS])(Z80EX_WORD, bool, Z80EX_BYTE&);
bool (* hnd_z80write[MAX_HANDLERS])(Z80EX_WORD, Z80EX_BYTE);
bool (* hnd_z80input[MAX_HANDLERS])(Z80EX_WORD, Z80EX_BYTE&);
bool (* hnd_z80output[MAX_HANDLERS])(Z80EX_WORD, Z80EX_BYTE);
void (* hnd_frameStart[MAX_HANDLERS])(void);
void (* hnd_afterFrameRender[MAX_HANDLERS])(void);
void (* hnd_reset[MAX_HANDLERS])(void); 

void AttachZ80ReadHandler(bool (* func)(Z80EX_WORD, bool, Z80EX_BYTE&))
{
	if (cnt_z80read >= MAX_HANDLERS) StrikeError("Increase MAX_HANDLERS");
	hnd_z80read[cnt_z80read++] = func;
}

void AttachZ80WriteHandler(bool (* func)(Z80EX_WORD, Z80EX_BYTE))
{
	if (cnt_z80write >= MAX_HANDLERS) StrikeError("Increase MAX_HANDLERS");
	hnd_z80write[cnt_z80write++] = func;
}

void AttachZ80InputHandler(bool (* func)(Z80EX_WORD, Z80EX_BYTE&))
{
	if (cnt_z80input >= MAX_HANDLERS) StrikeError("Increase MAX_HANDLERS");
	hnd_z80input[cnt_z80input++] = func;
}

void AttachZ80OutputHandler(bool (* func)(Z80EX_WORD, Z80EX_BYTE))
{
	if (cnt_z80output >= MAX_HANDLERS) StrikeError("Increase MAX_HANDLERS");
	hnd_z80output[cnt_z80output++] = func;
}

void AttachFrameStartHandler(void (* func)(void))
{
	if (cnt_frameStart >= MAX_HANDLERS) StrikeError("Increase MAX_HANDLERS");
	hnd_frameStart[cnt_frameStart++] = func;
}

void AttachAfterFrameRenderHandler(void (* func)(void))
{
	if (cnt_afterFrameRender >= MAX_HANDLERS) StrikeError("Increase MAX_HANDLERS");
	hnd_afterFrameRender[cnt_afterFrameRender++] = func;
}

/*void AttachSDLHandler(int eventType, bool (* func)(SDL_Event&))
{
	if (cnt_sdl >= MAX_HANDLERS) StrikeError("Increase MAX_HANDLERS");
	types_sdl[cnt_sdl] = eventType;
	hnd_sdl[cnt_sdl++] = func;
}*/

void AttachResetHandler(void (* func)(void))
{
	if (cnt_reset >= MAX_HANDLERS) StrikeError("Increase MAX_HANDLERS");
	hnd_reset[cnt_reset++] = func;
} 