#pragma once

#include <windows.h>
#include "mapfile.h"
#include "defines.h"
#include <comutil.h>

struct CONFIG_ITEM
{
	_bstr_t name;
	_bstr_t data;
};

class C_Config
{
public:

	C_Config()
	{
		
	}
	~C_Config()
	{
		RegCloseKey(m_regKey);
	}

	void Init(wchar_t* filename)
	{
		char buf[128];
		lastConfigItem = 0;
		C_MapFile mf;
		mf.Read(filename);
		while(!mf.Eof())
		{
			mf.GetS((unsigned char*)buf, sizeof(buf));
			if (buf[0]=='#')
				continue;
			char* uk = buf;
			while(*uk!='=' && *uk!=0) uk++;
			if (*uk=='=')
			{
				*uk=0;
				config_items[lastConfigItem].name = buf;
				config_items[lastConfigItem].data = (uk+1);
				lastConfigItem++;
			}
		}
		mf.Close();
	}

	bool GetInt(wchar_t *path, int *value)
	{
		
	}
	void SetInt(char *path, int value);

	bool GetString(wchar_t *path, wchar_t **value)
	{
		wchar_t* buf = new wchar_t[128];
		for (int i=0;i<lastConfigItem;i++)
			if (wcscmp(config_items[i].name, path)==0)
			{
				wcscpy(buf,( wchar_t*)config_items[i].data);
				*value = buf;
				return true;
			}
		return false;
	}

	bool GetBool(wchar_t *path)
	{
		wchar_t* buf = new wchar_t[128];
		for (int i=0;i<lastConfigItem;i++)
			if (wcscmp(config_items[i].name, path)==0)
			{
				if (wcscmp(config_items[i].data,L"true")==0 || wcscmp(config_items[i].data,L"yes")==0)
					return true;
				else
					return false;
			}
		return false;
	}


	void SetString(char *path, char *value);
	bool GetBool(char *path, bool *value) {return 0;}
	void SetBool(char *path, bool value);
	void Remove(char *path);

private:
	HKEY m_regKey;	
	CONFIG_ITEM config_items[64];
	WORD lastConfigItem;
};
