#pragma once

#include <windows.h>
#include <comutil.h>

extern _bstr_t filePathString;

class C_MapFile
{
	public:

	C_MapFile() {}
	~C_MapFile() {}

	void Read(wchar_t *filename)
	{
		_bstr_t fileName;
		if (wcschr(filename, '\\')==0 && wcschr(filename, '/')==0 && wcschr(filename, ':')==0)
			fileName = filePathString + filename;
		else
			fileName = filename;

		DWORD dw;
	#ifdef _WIN32_WCE
		m_hFile = CreateFileForMapping((wchar_t*)fileName, GENERIC_READ, 0, 0, OPEN_EXISTING, 0,0);
	#else
		m_hFile = CreateFile((wchar_t*)fileName, GENERIC_READ, 0, 0, OPEN_EXISTING, 0,0);
	#endif
		DWORD p2 = GetLastError();
		m_dwSize = GetFileSize(m_hFile, &dw);
		m_hMap = CreateFileMapping(m_hFile, 0, PAGE_READONLY, 0, m_dwSize, NULL); 
		DWORD p = GetLastError();
		//data = new unsigned char[m_dwSize];
		data = (unsigned char*)MapViewOfFile(m_hMap, FILE_MAP_READ, 0, 0, m_dwSize); 
		pointer = 0;
	}

	void Write(wchar_t *filename) {}
	void Append(wchar_t *filename);
	void Close(void)
	{
		UnmapViewOfFile(data);
		CloseHandle(m_hMap);
		CloseHandle(m_hFile);
		//delete data;
	}

	void PrintF(char *fmt, ...);
	void PutBYTE(BYTE b) {}
	void PutWORD(WORD w) {}
	void PutDWORD(DWORD d);
	void PutC(int c);

	void GetS(unsigned char *buf, int size)
	{
		DWORD i;
		for (i=pointer; i < m_dwSize; i++)
			if (data[i] == '\r' || data[i] == '\n')
			{
				DWORD length = i-pointer > size ? size : i-pointer;
				strncpy((char*)buf, (char*)&data[pointer], length);
				buf[length] = 0;
				pointer = i + 1;
				while (data[pointer] == '\r' || data[pointer] == '\n') pointer++;
				break;
			}
		if (i==m_dwSize)
		{
			DWORD length = i-pointer;
			strncpy((char*)buf, (char*)&data[pointer], length);
			buf[length] = 0;
			pointer = m_dwSize;
			while (data[pointer] == '\r' || data[pointer] == '\n') pointer++;
		}
	}

	BYTE GetBYTE(void)
	{
		return data[pointer++];
	}
	WORD GetWORD(void)
	{
		WORD b;
		memcpy(&b, &data[pointer], 2);
		pointer += 2;
		return b;
	}

	DWORD GetDWORD(void)
	{
		DWORD b;
		memcpy(&b, &data[pointer], 4);
		pointer += 4;
		return b;
	}
	int GetC(void) {return 0;}

	int ReadBlock(void *buf, int size)
	{
		memcpy(buf, &data[pointer], size);
		pointer += size;
		return size;
	}

	void WriteBlock(void *buf, int size) {}

	bool Eof(void)
	{
		return (pointer >= m_dwSize);
	}
	void UnGetBYTE(BYTE b);
	void UnGetC(int c);

	static long FileSize(wchar_t *filename)
	{
		DWORD d;
		HANDLE hFile = CreateFile((wchar_t*)filename, GENERIC_READ, 0, 0, OPEN_EXISTING, 0,0);
		DWORD fileSize = GetFileSize(hFile, &d);
		CloseHandle(hFile);
		return fileSize;
	}

	static bool FileExists(wchar_t *filename);

//	long GetFilePointer(void);
	void SetFilePointer(long fp);

	private:
		HANDLE m_hFile;
		HANDLE m_hMap;
		unsigned char* data;
		DWORD m_dwSize;
		DWORD pointer;
};
