#pragma once

#include "ScreenInputDevice.h"
#include "Speccy.h"
#include "BIN.h"

extern int keyboard[8];
extern wchar_t filePath[128];
extern CSpeccy* spec;
extern s_Params params;

class CScreenKeyboard : public CScreenInputDevice
{
public:
	CScreenKeyboard()
	{
		capsIsOn = false;
		symbIsOn = false;
		shiftNeedOff = false;
	}

	~CScreenKeyboard();

	void Init(CGapiDraw* pGlobal, bool vga = false)
	{
		CScreenInputDevice::Init(pGlobal, vga);
		if (vga)	//   
		{
			HRESULT hra = inputDeviceSurface->CreateSurface(0, filePathString+L"keyboard_vga.png");
			top = 640-256;
		}
		else
		{
			HRESULT hra = inputDeviceSurface->CreateSurface(0, filePathString+L"keyboard.png");
			top = 320-128;
		}
		if (params.isVga)	//   
		{
			keyboardBorder = 640-256 + 16;
			halfWidth = 240;
			buttonWidth = 48;
			buttonHeight = 40;
		}
		else
		{
			keyboardBorder = 320-128 + 8;
			halfWidth = 120;
			buttonWidth = 24;
			buttonHeight = 20;
		}
		Sleep(1);
	}
	
	void ProcessStylusDown(POINT p)
	{
		unsigned char plr, mplr, nkey;
		unsigned char halfrowmap[] = {3, 4, 2, 5, 1, 6, 0, 7}; //       
		if (p.y<top)
		{
			//spec->LoadZ80Snap(filePathString+L"snap.z80");
			return;
		}
		plr = (p.y - keyboardBorder)/buttonHeight;
		mplr = p.x/halfWidth;
		nkey = p.x/buttonWidth - 5*mplr;
		if (mplr)
			lastKey = (BIN(0x10000) >> nkey);
		else
			lastKey = (BIN(0x00001) << nkey);

		if ((keyboard[7] & 0x2) && (keyboard[0] & 0x1))
		{
			keyboard[7] |= 0x2;
			symbIsOn = false;
			shiftNeedOff = false;
			keyboard[0] |= 0x1;
			capsIsOn = false;
		}

		poluryad = halfrowmap[2*(plr)+mplr];
		keyboard[poluryad] &= ~lastKey;
		if (capsIsOn || symbIsOn) shiftNeedOff = true;		
	}

	void ProcessStylusUp(POINT p)
	{
		if (p.y<top)
			return;
		if (shiftNeedOff)
		{
			keyboard[7] |= 0x2;
			symbIsOn = false;
			shiftNeedOff = false;
			keyboard[0] |= 0x1;
			capsIsOn = false;
		}
		if (poluryad==0 && (lastKey & 0x1)) 
		{
			capsIsOn = true;
			shiftNeedOff = false;
			return;
		}
		if (poluryad==7 && (lastKey & 0x2))
		{
			symbIsOn = true;
			shiftNeedOff = false;
			return;
		}
		keyboard[poluryad] |= lastKey;
	}

private:
	unsigned lastKey, poluryad;
	bool capsIsOn, symbIsOn,  shiftNeedOff;
//	CGapiSurface* keyboard_surf;
	WORD keyboardBorder, halfWidth, buttonWidth, buttonHeight;
};