#include <string.h>

#include "keys.h"
#include "keyboard.h"
#include "../../mapfile.h"
#include "../../exceptions.h"
#include "../../attach_funcs.h"
#include "../../defines.h"
#include <comutil.h>

bool C_Keyboard::hostKeyPressed[SDLK_LAST];
C_Keyboard::s_HostKey C_Keyboard::hostKeys[SDLK_LAST];
int keyboard[8];
extern s_Action cfgActions[];

bool b_shift, b_ctrl, b_alt;
bool waitForNextDown, waitForNextUp;

struct ZX_PC_KEY_ASSIGN
{
	short zxKey1;
	short zxKey2;
	short pcKey1;
	short pcKey2;
	WORD pcKey1sym, pcKey2sym;
	void (* action)(void);
	bool pressed;
};

ZX_PC_KEY_ASSIGN assigns[SDLK_LAST];
WORD zxKeyCount = 0;
void C_Keyboard::ReadKbdConfig(void)
{
	int i, hkey, ln, kmod, hkeyadd, kmodadd;
	C_MapFile  fl;
	s_ZxKeys zxk;
	char buf[0x100];
	char *s, *p;
	void (* act)(void);
	bool canAct;

	for (i = 0; i < SDLK_LAST; i++)
	{
		assigns[i].action = NULL;
		assigns[i].zxKey1 = -1;
		assigns[i].zxKey2 = -1;
		assigns[i].pcKey1 = -1;
		assigns[i].pcKey2 = -1;
		assigns[i].pressed = false;
	}

//	if (!config.GetString("root/Keys", &fname)) throw C_E(E_General, "root/Keys not found in config");

	ln = 0;

	_bstr_t fname = L"keys.config";
	fl.Read(fname);
	while (!fl.Eof())
	{
		fl.GetS((unsigned char*)buf, sizeof(buf));
		ln++;
		s = buf;

		while (*s && ((*s)==' ' || (*s)==9)) s++;
		if (!(*s)) continue;
		if ((*s) == '#') continue;

		p = s;
		while (*s && (*s)!=' ' && (*s)!=9) s++;
		if (!(*s)) StrikeError("Bad %s file at line %d", fname, ln);

		*s = 0;
		s++;

		for (i=0, hkey=0, hkeyadd=0; cfgHostKeys[i].cfgname[0]; i++)
		{
			if (!strcmp(p, cfgHostKeys[i].cfgname))
			{
				assigns[zxKeyCount].pcKey1 = i;
				assigns[zxKeyCount].pcKey1sym = cfgHostKeys[i].keysym;
				hkey = cfgHostKeys[i].keysym;
				hkeyadd = cfgHostKeys[i].keysymadd;
				break;
			}
		}

		if (!hkey) StrikeError("Host key \"%s\" not found at line %d of %s", p, ln, fname);
		kmod = 0;

		while (*s && ((*s)==' ' || (*s)==9)) s++;
		if (!(*s)) StrikeError("ZX keys not found at line %d of %s", ln, fname);

		if ((*s) != ':')
		{
			kmod = hkey;
			kmodadd = hkeyadd;

			p = s;
			while (*s && (*s)!=' ' && (*s)!=9) s++;
			if (!(*s)) StrikeError("Bad %s file at line %d", fname, ln);

			*s = 0;
			s++;

			for (i=0, hkey=0, hkeyadd=0; cfgHostKeys[i].cfgname[0]; i++)
			{
				if (!strcmp(p, cfgHostKeys[i].cfgname))
				{
					assigns[zxKeyCount].pcKey2 = i;
					assigns[zxKeyCount].pcKey2sym = cfgHostKeys[i].keysym;
					hkey = cfgHostKeys[i].keysym;
					hkeyadd = cfgHostKeys[i].keysymadd;
					break;
				}
			}

			if (!hkey) StrikeError("Host key \"%s\" not found at line %d of %s", p, ln, fname);

			while (*s && ((*s)==' ' || (*s)==9)) s++;
			if (!(*s)) StrikeError("ZX keys not found at line %d of %s", ln, fname);

			if ((*s) != ':') StrikeError("Bad %s file at line %d", fname, ln);
		}

		canAct = true;
		act = NULL;
		zxk.count = 0;
		s++;

		short * zxKey = &assigns[zxKeyCount].zxKey1;

		while (*s)
		{
			while (*s && ((*s)==' ' || (*s)==9)) s++;
			if (!(*s)) break;
			if ((*s) == '#') break;

			if ((*s) == '@')
			{
				if (canAct)
				{
					s++;
					p = s;
					while (*s && (*s)!=' ' && (*s)!=9) s++;
					if (*s) *(s++) = 0;

					for (i=0; cfgActions[i].name[0]; i++) {
						if (!strcmp(p, cfgActions[i].name)) {
							assigns[zxKeyCount].action = cfgActions[i].action;
							act = cfgActions[i].action;
							break;
						}
					}

					if (act == NULL) StrikeError("Action %s not defined (line %d of %s)", p, ln, fname);
					break;
				}
				else StrikeError("Mixing ZX keys and actions are not allowed (line %d of %s)", ln, fname);
			}

			if (zxk.count >= MAX_ZX_KEYS_MAP) StrikeError("Maximum %d ZX keys per line allowed (line %d of %s)", MAX_ZX_KEYS_MAP, ln, fname);
			canAct = false;

			p = s;
			while (*s && (*s)!=' ' && (*s)!=9) s++;
			if (*s) *(s++) = 0;

			for (i=0; cfgZxKeys[i].cfgname[0]; i++) {
				if (!strcmp(p, cfgZxKeys[i].cfgname)) break;
			}

			*zxKey = i;
			zxKey = &assigns[zxKeyCount].zxKey2;

			if (!cfgZxKeys[i].cfgname[0]) StrikeError("ZX key \"%s\" not found at line %d of %s", p, ln, fname);

			zxk.portnum[zxk.count] = cfgZxKeys[i].portnum;
			zxk.bitmask[zxk.count] = cfgZxKeys[i].bitmask;
			zxk.count++;
		}

		if (!zxk.count && !act) StrikeError("No ZX keys or actions defined at line %d of %s", ln, fname);

		/*if (kmod)
		{
			if (hostKeys[hkey].mods.count >= MAX_HOST_KEY_MODS) StrikeError("Maximum %d overloads for host key allowed (line %d of %s)", MAX_HOST_KEY_MODS, ln, fname);
			hostKeys[hkey].mods.keyMod[hostKeys[hkey].mods.count] = kmod;
			hostKeys[hkey].mods.actions[hostKeys[hkey].mods.count] = act;
			hostKeys[hkey].mods.zxKeys[hostKeys[hkey].mods.count] = zxk;
			hostKeys[hkey].mods.count++;

			if (hkeyadd)
			{
				if (hostKeys[hkeyadd].mods.count >= MAX_HOST_KEY_MODS) StrikeError("Maximum %d overloads for host key allowed (line %d of %s)", MAX_HOST_KEY_MODS, ln, fname);
				hostKeys[hkeyadd].mods.keyMod[hostKeys[hkeyadd].mods.count] = kmod;
				hostKeys[hkeyadd].mods.actions[hostKeys[hkeyadd].mods.count] = act;
				hostKeys[hkeyadd].mods.zxKeys[hostKeys[hkeyadd].mods.count] = zxk;
				hostKeys[hkeyadd].mods.count++;
			}

			if (kmodadd)
			{
				if (hostKeys[hkey].mods.count >= MAX_HOST_KEY_MODS) StrikeError("Maximum %d overloads for host key allowed (line %d of %s)", MAX_HOST_KEY_MODS, ln, fname);
				hostKeys[hkey].mods.keyMod[hostKeys[hkey].mods.count] = kmodadd;
				hostKeys[hkey].mods.actions[hostKeys[hkey].mods.count] = act;
				hostKeys[hkey].mods.zxKeys[hostKeys[hkey].mods.count] = zxk;
				hostKeys[hkey].mods.count++;

				if (hkeyadd)
				{
					if (hostKeys[hkeyadd].mods.count >= MAX_HOST_KEY_MODS) StrikeError("Maximum %d overloads for host key allowed (line %d of %s)", MAX_HOST_KEY_MODS, ln, fname);
					hostKeys[hkeyadd].mods.keyMod[hostKeys[hkeyadd].mods.count] = kmodadd;
					hostKeys[hkeyadd].mods.actions[hostKeys[hkeyadd].mods.count] = act;
					hostKeys[hkeyadd].mods.zxKeys[hostKeys[hkeyadd].mods.count] = zxk;
					hostKeys[hkeyadd].mods.count++;
				}
			}
		}
		else
		{
			hostKeys[hkey].normal = zxk;
			hostKeys[hkey].action = act;
			if (hkeyadd) hostKeys[hkeyadd].normal = zxk;
		}*/
		zxKeyCount++;
	}
	fl.Close();
}

void C_Keyboard::Init(void)
{
	int i;
	ReadKbdConfig();
//	AttachSDLHandler(SDL_KEYDOWN, OnKeyDown);
//	AttachSDLHandler(SDL_KEYUP, OnKeyUp);
	AttachZ80InputHandler(OnInputByte);
	for (i = 0; i < 8; i++) keyboard[i] = 255;

	b_shift = false;
	b_ctrl = false;
	b_alt = false;
	waitForNextDown = false;
	waitForNextUp = false;
}

void C_Keyboard::Close(void)
{
}

bool C_Keyboard::OnKeyDown(DWORD dwKey)
{
	if (waitForNextDown)
	{
		dwKey |= 0x5b00;
		waitForNextDown = false;
	}
	if (dwKey == 0x5b)
		waitForNextDown = true;
	for (int i=0;i<zxKeyCount;i++)
	{
		if (assigns[i].pcKey2 != -1 && dwKey == assigns[i].pcKey2sym)
		{
			if ((assigns[i].pcKey1sym == VK_SHIFT		&& b_shift) ||
					(assigns[i].pcKey1sym == VK_CONTROL && b_ctrl) ||
					(assigns[i].pcKey1sym == VK_MENU			&& b_alt))
			{
				keyboard[cfgZxKeys[assigns[i].zxKey1].portnum] &= ~cfgZxKeys[assigns[i].zxKey1].bitmask;
				if (assigns[i].zxKey2!=-1)
					keyboard[cfgZxKeys[assigns[i].zxKey2].portnum] &= ~cfgZxKeys[assigns[i].zxKey2].bitmask;
				assigns[i].pressed = true;
				break;
			}

		}
		if (dwKey == assigns[i].pcKey1sym && assigns[i].pcKey2==-1)
		{
			if (assigns[i].action != NULL)
			{
				assigns[i].action();
				break;
			}
			keyboard[cfgZxKeys[assigns[i].zxKey1].portnum] &= ~cfgZxKeys[assigns[i].zxKey1].bitmask;
			if (assigns[i].zxKey2!=-1)
				keyboard[cfgZxKeys[assigns[i].zxKey2].portnum] &= ~cfgZxKeys[assigns[i].zxKey2].bitmask;
			assigns[i].pressed = true;
			break;
		}
	}
	if (dwKey == VK_SHIFT)		b_shift =	true; else
	if (dwKey == VK_CONTROL)	b_ctrl	= true; else
	if (dwKey == VK_MENU)			b_alt		= true;
	return false;
}

bool C_Keyboard::OnKeyUp(DWORD dwKey)
{
	if (waitForNextUp)
	{
		dwKey |= 0x5b00;
		waitForNextUp = false;
	}
	if (dwKey == 0x5b)
		waitForNextUp = true;

	for (int i=0; i < zxKeyCount; i++)
	{
		if (assigns[i].pressed && (assigns[i].pcKey1sym == dwKey || assigns[i].pcKey2sym == dwKey))
		{
			if (assigns[i].pcKey2 == -1)
			{
				bool clear = true;
				for (int j=0; j < zxKeyCount; j++)
				{
					if (assigns[j].pressed && assigns[j].zxKey1 == assigns[i].zxKey1 && i!=j)
					{
						clear = false;
						break;
					}
				}
				if (clear) keyboard[cfgZxKeys[assigns[i].zxKey1].portnum] |= cfgZxKeys[assigns[i].zxKey1].bitmask;
				if (assigns[i].zxKey2!=-1)
					keyboard[cfgZxKeys[assigns[i].zxKey2].portnum] |= cfgZxKeys[assigns[i].zxKey2].bitmask;
				assigns[i].pressed = false;
				break;
			}
		}
	}

	if (dwKey == VK_SHIFT)		b_shift=	false; else
	if (dwKey == VK_CONTROL) b_ctrl	= false; else
	if (dwKey == VK_MENU)			b_alt		= false;
	return true;
}

bool C_Keyboard::OnInputByte(Z80EX_WORD port, Z80EX_BYTE &retval)
{
	int i, hport;

	if (port & 1) return false;

	retval = 255;
	hport = (port >> 8);
	for (i = 0; i < 8; i++) {
		if (!(hport & 1)) retval &= keyboard[i];
		hport >>= 1;
	}
	return true;
} 