#ifndef _KEYS_H_INCLUDED_
#define _KEYS_H_INCLUDED_

#include <windows.h>
#include "../../bin.h"

#define VK_HARDWARE1 0x5bc1
#define VK_HARDWARE2 0x5bc2
#define VK_HARDWARE3 0x5bc3
#define VK_HARDWARE4 0x5bc4 
#define VK_HARDWARE5 0x5bc5
#define VK_HARDWARE6 0x5bc6


struct s_CfgHostKey
{
	char *cfgname;
	int keysym;
	int keysymadd;
};

struct s_CfgZxKey
{
	char *cfgname;
	int portnum;
	int bitmask;
};

s_CfgHostKey cfgHostKeys[] = {
	{"esc",       VK_ESCAPE,	0},
	{"f1",        VK_F1,		0},
	{"f2",        VK_F2,		0},
	{"f3",        VK_F3,		0},
	{"f4",        VK_F4,		0},
	{"f5",        VK_F5,		0},
	{"f6",        VK_F6,		0},
	{"f7",        VK_F7,		0},
	{"f8",        VK_F8,		0},
	{"f9",        VK_F9,		0},
	{"f10",       VK_F10,		0},
	{"f11",       VK_F11,		0},
	{"f12",       VK_F12,		0},
	{"ins",       VK_INSERT,	0},
	{"home",      VK_HOME,	0},
	{"del",       VK_DELETE,	0},
	{"end",       VK_END,		0},
	{"pgup",      VK_PRIOR ,	0},
	{"pgdn",      VK_NEXT,	0},
	{"`",         '`',		0},
	{"1",         '1',		0},
	{"2",         '2',		0},
	{"3",         '3',		0},
	{"4",         '4',		0},
	{"5",         '5',		0},
	{"6",         '6',		0},
	{"7",         '7',		0},
	{"8",         '8',		0},
	{"9",         '9',		0},
	{"0",         '0',		0},
	{"-",         '-',		0},
	{"=",         '=',		0},
	{"\\",        '\\',		0},
	{"backspace", VK_BACK,	0},
	{"tab",       VK_TAB,		0},
	{"q",         'Q',		0},
	{"w",         'W',		0},
	{"e",         'E',		0},
	{"r",         'R',		0},
	{"t",         'T',		0},
	{"y",         'Y',		0},
	{"u",         'U',		0},
	{"i",         'I',		0},
	{"o",         'O',		0},
	{"p",         'P',		0},
	{"[",         '[',		0},
	{"]",         ']',		0},
	{"ent",       VK_RETURN,	0},
	{"caps",      VK_CAPITAL,	0},
	{"a",         'A',		0},
	{"s",         'S',		0},
	{"d",         'D',		0},
	{"f",         'F',		0},
	{"g",         'G',		0},
	{"h",         'H',		0},
	{"j",         'J',		0},
	{"k",         'K',		0},
	{"l",         'L',		0},
	{";",         ';',		0},
	{"'",         '\'',		0},
	{"z",         'Z',		0},
	{"x",         'X',		0},
	{"c",         'C',		0},
	{"v",         'V',		0},
	{"b",         'B',		0},
	{"n",         'N',		0},
	{"m",         'M',		0},
	{",",         ',',		0},
	{".",         '.',		0},
	{"/",         '/',		0},
	{"shift",    VK_SHIFT,	0},
	{"alt",				VK_MENU,	0},
	{"spc",       VK_SPACE,	0},
	{"ctrl",     VK_CONTROL,	0},
	{"up",        VK_UP,		0},
	{"down",      VK_DOWN,	0},
	{"left",      VK_LEFT,	0},
	{"right",     VK_RIGHT,	0},
	{"numlock",   VK_NUMLOCK,	0},
	{"hw1",				VK_HARDWARE1, 0},
	{"hw2",				VK_HARDWARE2, 0},
	{"hw3",				VK_HARDWARE3, 0},
	{"hw4",				VK_HARDWARE4, 0},
	{"hw5",				VK_HARDWARE5, 0},
	{"hw6",				VK_HARDWARE6, 0},
	{"",          0}
};

s_CfgZxKey cfgZxKeys[] = {
	{"spc", 7, BIN(0x00001)},
	{ "ss", 7, BIN(0x00010)},	
	{  "m", 7, BIN(0x00100)},	
	{  "n", 7, BIN(0x01000)},	
	{  "b", 7, BIN(0x10000)},	

	{"ent", 6, BIN(0x00001)},
	{  "l", 6, BIN(0x00010)},
	{  "k", 6, BIN(0x00100)},
	{  "j", 6, BIN(0x01000)},
	{  "h", 6, BIN(0x10000)},

	{  "p", 5, BIN(0x00001)},
	{  "o", 5, BIN(0x00010)},
	{  "i", 5, BIN(0x00100)},
	{  "u", 5, BIN(0x01000)},
	{  "y", 5, BIN(0x10000)},

	{  "0", 4, BIN(0x00001)},
	{  "9", 4, BIN(0x00010)},
	{  "8", 4, BIN(0x00100)},
	{  "7", 4, BIN(0x01000)},
	{  "6", 4, BIN(0x10000)},

	{  "1", 3, BIN(0x00001)},
	{  "2", 3, BIN(0x00010)},
	{  "3", 3, BIN(0x00100)},
	{  "4", 3, BIN(0x01000)},
	{  "5", 3, BIN(0x10000)},

	{  "q", 2, BIN(0x00001)},
	{  "w", 2, BIN(0x00010)},
	{  "e", 2, BIN(0x00100)},
	{  "r", 2, BIN(0x01000)},
	{  "t", 2, BIN(0x10000)},

	{  "a", 1, BIN(0x00001)},
	{  "s", 1, BIN(0x00010)},
	{  "d", 1, BIN(0x00100)},
	{  "f", 1, BIN(0x01000)},
	{  "g", 1, BIN(0x10000)},

	{ "cs", 0, BIN(0x00001)},
	{  "z", 0, BIN(0x00010)},
	{  "x", 0, BIN(0x00100)},
	{  "c", 0, BIN(0x01000)},
	{  "v", 0, BIN(0x10000)},

	{   "", 0, 0}
};

#endif
