#pragma once

#include <windows.h>
#include <comutil.h>

extern _bstr_t filePathString;


class C_File 
{
	public:

	C_File () {}
	~C_File () {}

	void Read(wchar_t *filename)
	{
		_bstr_t fileName;
		if (wcschr(filename, '\\')==0 && wcschr(filename, '/')==0 && wcschr(filename, ':')==0)
			fileName = filePathString + filename;
		else
			fileName = filename;

		m_hFile = CreateFile((wchar_t*)fileName, GENERIC_READ, 0, 0, OPEN_EXISTING, 0,0);
		m_eof = false;
	}

	void Write(wchar_t *filename) {}
	void Append(wchar_t *filename);
	void Close(void)
	{
		CloseHandle(m_hFile);
	}

	void PrintF(char *fmt, ...);
	void PutBYTE(BYTE b) {}
	void PutWORD(WORD w) {}
	void PutDWORD(DWORD d);
	void PutC(int c);

	void GetS(char *buf, int size);
	BYTE GetBYTE(void)
	{
		BYTE b;
		DWORD br;
		bool bResult = ReadFile(m_hFile, &b, 1, &br, 0);
		if (bResult && (br == 0)) m_eof = true;
		return b;
	}
	WORD GetWORD(void)
	{
		WORD b;
		DWORD br;
		bool bResult = ReadFile(m_hFile, &b, 2, &br, 0);
		if (bResult && (br == 0)) m_eof = true;
		return b;
	}

	DWORD GetDWORD(void)
	{
		DWORD b;
		DWORD br;
		bool bResult = ReadFile(m_hFile, &b, 4, &br, 0);
		if (bResult && (br == 0)) m_eof = true;
		return b;
	}
	int GetC(void);

	int ReadBlock(void *buf, int size)
	{
		DWORD br;
		bool bResult = ReadFile(m_hFile, buf, size, &br, 0);
		if (bResult && (br == 0)) m_eof = true;
		return (int)br;
	}

	void WriteBlock(void *buf, int size) {}

	bool Eof(void)
	{
		return m_eof;
	}
	void UnGetBYTE(BYTE b);
	void UnGetC(int c);

	static long FileSize(wchar_t *filename)
	{
		DWORD d;
		HANDLE hFile = CreateFile((wchar_t*)filename, GENERIC_READ, 0, 0, OPEN_EXISTING, 0,0);
		DWORD fileSize = GetFileSize(hFile, &d);
		CloseHandle(hFile);
		return fileSize;
	}

	static bool FileExists(wchar_t *filename);

//	long GetFilePointer(void);
	void SetFilePointer(long fp);

	private:
		HANDLE m_hFile;
		bool m_eof;
};
