#ifndef MYAPPLICATION_INCLUDED
#define MYAPPLICATION_INCLUDED

#pragma once

#include "GapiApplication.h"
#include "GapiDrawExtension.h" // CPoint and CRect
#include "ScreenInputDevice.h"
#include <comutil.h>

wchar_t filePath[128];
_bstr_t filePathString;

//-----------------------------------------------------------------------------
// Name: class CMyApplication
// Desc: Main class to run this application. Most functionality is inherited
//       from the CGapiApplication base class.
//-----------------------------------------------------------------------------
class CMyApplication : public CGapiApplication
{
// Construction
public:
	CMyApplication(const GDAPPCONFIG& config);

// Attributes
protected:
	CScreenInputDevice* m_screenKeyboard;
// Operations
protected:

// Implementation
public:
	virtual HRESULT InitInstance();
	virtual HRESULT ExitInstance();
	virtual HRESULT OnMinimize();
	virtual HRESULT OnRestore();
	virtual HRESULT CreateSysMemSurfaces(CGapiDisplay* pDisplay, HINSTANCE hInstance);
	virtual HRESULT CreateVidMemSurfaces(CGapiDisplay* pDisplay, HINSTANCE hInstance);
	virtual HRESULT ProcessNextFrame(CGapiSurface* pBackBuffer, DWORD dwFlags);

	virtual HRESULT KeyDown(DWORD dwKey, GDKEYLIST& keylist);
	virtual HRESULT KeyUp(DWORD dwKey, GDKEYLIST& keylist);
	virtual HRESULT StylusDown(POINT p);
	virtual HRESULT StylusUp(POINT p);
	virtual HRESULT StylusDblClk(POINT p);
	virtual HRESULT StylusMove(POINT p);
	virtual	HRESULT Shutdown();
	virtual ~CMyApplication();
};

#endif // MYAPPLICATION_INCLUDED
